//funkce pouzite pri importu dat z API

//------------------------------------------------------------------------------
//deklarace funkci definovanych v jinych souborech
procedure SerieChange(sender:TObject); forward;  //LabForGg.fceForm.pas
procedure butOwnerIdOnClick(sender:TObject); forward;  //LabForGg.fceForm.pas
procedure cbLabViewOnChange(sender:TObject); forward;  //LabForGg.fceForm.pas
//------------------------------------------------------------------------------
{ $define CHECK_XML}

{$ifdef CHEXK_XML}
procedure CheckXmlInit;
var n:integer;
begin
  //inicializuje popis struktur jednotlivych XML
  //posledni zmeny:
  //          20.12.2021 pridana Adventure Type i do Basic
  //          29.4.2021 pridana polozka AdventureType, IsFinal, UnlockingStages
  //          17.2.2021 pridana polozka ChallengeType, MultiChoiceOptions
  //          28.1.2021 doplneno FindCodeHashBase16v2
  n:=-1;   //polozky z BasicInfo
  Inc(n); rXmlBasic.Items[n].sName:='AdventureType';                   //20.21.2021
  Inc(n); rXmlBasic.Items[n].sName:='CreatedUtc';
  Inc(n); rXmlBasic.Items[n].sName:='DeepLink';
  Inc(n); rXmlBasic.Items[n].sName:='Description';
  Inc(n); rXmlBasic.Items[n].sName:='FirebaseDynamicLink';
  Inc(n); rXmlBasic.Items[n].sName:='Id';
  Inc(n); rXmlBasic.Items[n].sName:='IsArchived';
  Inc(n); rXmlBasic.Items[n].sName:='IsComplete';
  Inc(n); rXmlBasic.Items[n].sName:='IsTest';
  Inc(n); rXmlBasic.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlBasic.Items[n].sName:='Location';
  Inc(n); rXmlBasic.Items[n].sName:='MedianTimeToComplete';            //21.10.2021
  Inc(n); rXmlBasic.Items[n].sName:='OwnerPublicGuid';
  Inc(n); rXmlBasic.Items[n].sName:='PublishedUtc';
  Inc(n); rXmlBasic.Items[n].sName:='RatingsAverage';
  Inc(n); rXmlBasic.Items[n].sName:='RatingsTotalCount';
  Inc(n); rXmlBasic.Items[n].sName:='SmartLink';
  Inc(n); rXmlBasic.Items[n].sName:='StagesTotalCount';
  Inc(n); rXmlBasic.Items[n].sName:='Title';
  Inc(n); rXmlBasic.Items[n].sName:='Visibility';
  rXmlBasic.nCount:=n+1;

  n:=-1;   //polozky z Detailu, pro jednotlive labky
  Inc(n); rXmlLab.Items[n].sName:='AwardImageAsBase64String';
  Inc(n); rXmlLab.Items[n].sName:='AwardImageUrl';
  Inc(n); rXmlLab.Items[n].sName:='AwardVideoYouTubeId';
  Inc(n); rXmlLab.Items[n].sName:='ChallengeType';                   //17.2.2021
  Inc(n); rXmlLab.Items[n].sName:='CompletionAwardMessage';
  Inc(n); rXmlLab.Items[n].sName:='CompletionCode';
  Inc(n); rXmlLab.Items[n].sName:='DeleteAwardImage';
  Inc(n); rXmlLab.Items[n].sName:='Description';
  Inc(n); rXmlLab.Items[n].sName:='DescriptionVideoYouTubeId';
  Inc(n); rXmlLab.Items[n].sName:='FindCodeHashBase16';
  Inc(n); rXmlLab.Items[n].sName:='FindCodeHashBase16v2';            //29.1.2021
  Inc(n); rXmlLab.Items[n].sName:='GeofencingRadius';
  Inc(n); rXmlLab.Items[n].sName:='Id';
  Inc(n); rXmlLab.Items[n].sName:='IsComplete';
  Inc(n); rXmlLab.Items[n].sName:='IsFinal';                         //29.4.2021
  Inc(n); rXmlLab.Items[n].sName:='KeyImage';
  Inc(n); rXmlLab.Items[n].sName:='KeyImageAsBase64String';
  Inc(n); rXmlLab.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlLab.Items[n].sName:='LastUpdateDateTimeUtc';
  Inc(n); rXmlLab.Items[n].sName:='Location';
  Inc(n); rXmlLab.Items[n].sName:='MultiChoiceOptions';              //17.2.2021
  Inc(n); rXmlLab.Items[n].sName:='Question';
  Inc(n); rXmlLab.Items[n].sName:='Title';
  Inc(n); rXmlLab.Items[n].sName:='UnlockingStages';                 //29.4.2021
  rXmlLab.nCount:=n+1;

  n:=-1;   //polozky z Detailu, pro celou serii
  Inc(n); rXmlDetail.Items[n].sName:='AdventureType';                //29.4.2021
  Inc(n); rXmlDetail.Items[n].sName:='AwardImageAsBase64String';
  Inc(n); rXmlDetail.Items[n].sName:='AwardMessage';
  Inc(n); rXmlDetail.Items[n].sName:='AwardVideoYouTubeId';
  Inc(n); rXmlDetail.Items[n].sName:='ClonedSourceAdventureId';
  Inc(n); rXmlDetail.Items[n].sName:='CompletedGeocachesCount';
  Inc(n); rXmlDetail.Items[n].sName:='DeepLink';
  Inc(n); rXmlDetail.Items[n].sName:='Description';
  Inc(n); rXmlDetail.Items[n].sName:='FirebaseDynamicLink';
  Inc(n); rXmlDetail.Items[n].sName:='GeocacheSummaries';
  Inc(n); rXmlDetail.Items[n].sName:='Id';
  Inc(n); rXmlDetail.Items[n].sName:='IsComplete';
  Inc(n); rXmlDetail.Items[n].sName:='IsLinear';
  Inc(n); rXmlDetail.Items[n].sName:='IsTest';
  Inc(n); rXmlDetail.Items[n].sName:='KeyImageAsBase64String';
  Inc(n); rXmlDetail.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlDetail.Items[n].sName:='LastUpdateDateTimeUtc';
  Inc(n); rXmlDetail.Items[n].sName:='Location';
  Inc(n); rXmlDetail.Items[n].sName:='MedianTimeToComplete';            //9.10.2021
  Inc(n); rXmlDetail.Items[n].sName:='OwnerId';
  Inc(n); rXmlDetail.Items[n].sName:='OwnerUsername';
  Inc(n); rXmlDetail.Items[n].sName:='PublishedUtc';
  Inc(n); rXmlDetail.Items[n].sName:='RatingsAverage';
  Inc(n); rXmlDetail.Items[n].sName:='RatingsTotalCount';
  Inc(n); rXmlDetail.Items[n].sName:='ReviewsTotalCount';
  Inc(n); rXmlDetail.Items[n].sName:='SmartLinkString';
  Inc(n); rXmlDetail.Items[n].sName:='StagesTotalCount';
  Inc(n); rXmlDetail.Items[n].sName:='TestAdventureId';
  Inc(n); rXmlDetail.Items[n].sName:='Title';
  Inc(n); rXmlDetail.Items[n].sName:='TotalGeocachesCount';
  Inc(n); rXmlDetail.Items[n].sName:='Visibility';
  rXmlDetail.nCount:=n+1;
end;

function CheckXmlIndexOfName(aData:T_XML_STRUCT; sName:string):integer;
var i:integer;
begin
  //vyhleda polozku v popisu struktury
  Result:=-1;
  for i:=0 to aData.nCount-1 do begin
    if(aData.Items[i].sName=sName) then begin
      Result:=i;
      break;
    end;
  end;
end;

procedure CheckXmlVersion(Xml:TJclSimpleXMLElem; aData:T_XML_STRUCT; sType:string);
var i,j:integer;
    elem: TJclSimpleXMLElem;
    sErr:string;
begin
  //otestuje, zda v XML jsou ocekavane polozky a neni tam nic navic
  for i:=0 to Xml.Items.count-1 do begin
    elem:=XML.Items[i];
    j:=CheckXmlIndexOfName(aData,elem.name);
    if(j<0) then sErr:=sErr+'neznamy element: '+elem.name+CRLF
    else aData.Items[j].bExist:=true;
  end;
  for i:=0 to aData.nCount-1 do begin
    if(aData.Items[i].bExist<>true) then sErr:=sErr+'chybi element: '+aData.Items[i].sName+CRLF;
  end;
  if(sErr<>'') then ShowMessage('WARN: zmena XML formatu '+sType+CRLF+CRLF+sErr);
end;

procedure CheckXmlVersionBasic(Xml:TJclSimpleXML);
begin
  if(rXmlBasic.nCount=0) then CheckXmlInit();
  CheckXmlVersion(Xml.Root,rXmlBasic, 'Basic Info');
end;

procedure CheckXmlVersionDetail(Xml:TJclSimpleXML);
var elem: TJclSimpleXMLElem;
begin
  if(rXmlDetail.nCount=0) then CheckXmlInit();
  CheckXmlVersion(Xml.Root,rXmlDetail, 'Detail Info');
  //a jeste zkontrolujeme strukturu jedne labky
  elem:=XML.Root.Items.Itemnamed['GeocacheSummaries'];
  elem:=elem.Items.Itemnamed['GeocacheSummaryModel']
  CheckXmlVersion(elem,rXmlLab, 'Info o 1 LABce');
end;
{$endif}

function CmpGetForm:boolean;  //nacte pro porovnani poradi labek data z formulare
var i,j:integer;
begin
  Result:=false;
  //zjistime informace o labkach v databazi
  rCmpOld.sLabId:=GgForm_eIdTag.Text;
  rCmpOld.sSerieName:=AnsiToUtf(GgForm_eName.Text);
  rCmpOld.nCount:=0;
  rCmpOld.bCoord:=true; //je mozne porovnavat podle souradnic
  for i:=0 to GgForm_cbCount.ItemIndex do begin //vsechny labky serie v databazi
    rCmpOld.Items[rCmpOld.nCount].sGc:='';
    //jmeno pro porovnani prevedeme na ASCII a mala nismena
    rCmpOld.Items[rCmpOld.nCount].sName:=Trim(LowerCase(UtfToAscii(AnsiToUtf(aLab[rCmpOld.nCount].sName))));
    rCmpOld.Items[rCmpOld.nCount].sLabIdOrd:=aLab[rCmpOld.nCount].sLabIdOrd;
    rCmpOld.Items[rCmpOld.nCount].sCoord:=aLab[rCmpOld.nCount].sCoord;
    {$ifdef DEBUG_HELPER} LDH('rCmpOld[].sCoord='+rCmpOld.Items[rCmpOld.nCount].sCoord); {$endif}
    rCmpOld.Items[rCmpOld.nCount].idx:=-1;
    rCmpOld.Items[rCmpOld.nCount].iCmpType:=0;
    rCmpOld.Items[rCmpOld.nCount].iOk:=0;
    for j:=0 to i-1 do begin
      if(rCmpOld.Items[rCmpOld.nCount].sCoord=rCmpOld.Items[j].sCoord) then rCmpOld.bCoord:=false;
    end;
    Inc(rCmpOld.nCount);
  end;
  Result:=true;
end;

function CmpGetXml(Xml:TJclSimpleXML):boolean; //nacte pro porovnani poradi labek data z XML z API
var s:string;
    i,j:integer;
    x,y:extended;
    elem,eItems: TJclSimpleXMLElem;
begin
  Result:=false;
  rCmpNew.bCoord:=true;  //je mozne porovnavat podle souradnic
  rCmpNew.sLabId:=XML.Root.Items.Itemnamed['Id'].Value;
  rCmpNew.sSerieName:=XML.Root.Items.Itemnamed['Title'].Value;
  eItems:=XML.Root.Items.Itemnamed['GeocacheSummaries'];           //pocet labek v serii
  rCmpNew.nCount:=eItems.items.count;
  for i:=0 to rCmpNew.nCount-1 do begin
    elem:=eItems.items[i];
    rCmpNew.Items[i].sName:=Trim(LowerCase(UtfToAscii(elem.Items.Itemnamed['Title'].Value)));
    rCmpNew.Items[i].sLabIdOrd:=elem.Items.Itemnamed['Id'].Value;
    elem:=elem.Items.Itemnamed['Location']
    s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
    s:=s+', '+elem.Items.Itemnamed['Longitude'].Value;
    ParseWgsStr(s,x,y);
    rCmpNew.Items[i].sCoord:=FormatCoordNum(x,y);
    for j:=0 to i-1 do begin
      if(rCmpNew.Items[i].sCoord=rCmpNew.Items[j].sCoord) then rCmpNew.bCoord:=false;
    end;
    rCmpNew.Items[i].idx:=-1;
    rCmpNew.Items[i].iCmpType:=0;
    rCmpNew.Items[i].iOk:=0;
  end;
  Result:=true;
end;

procedure GetBasicInfo(sLabId,sXml:string);
var s,sUrl,sNew:string;
    i,iYear,iMon,iDay:integer;
    dt:TDateTime;
    lat,lon:extended;
    Xml:TJclSimpleXML;
    elem: TJclSimpleXMLElem;
begin
  //pokud neni zadany string s XML, nacteme jej
  if(sXml='') then begin
    //pres nas server
    sUrl:=sWEB_URL;
    s:=AddPostParam('','f','showXmlBasic');
    s:=AddPostParam(s,'fn',sLabId);
    //pridame identifikaci pluginu a ukoncime parametry
    s:=AddPostSender(s)+PostBoundary();
    {$ifdef DEBUG_HELPER} LDH('1. sUrl='+sUrl);{$endif}
    HttpAsk('POST',sUrl,'multipart/form-data; boundary='+POST_BOUNDARY,s,sXml);
    StringToFile(sXml,GetOfflineDir()+'ApiBasicInfo.xml');
    if(Length(sXml)<500) then begin
      ShowMessage('Chyba nacitani dat z API (zakladni info o serii).');
      exit;
    end;
  end;
  //parsujeme ziskane xml
  Xml:=TJclSimpleXml.Create();
  try
    //{$ifdef DEBUG_HELPER} LDH('Pred Load'); {$endif}
    //#### pro id=0f088495-bfac-4285-ae87-9be7b89eed03 to tu nejde, kdyz je pouzit
    //#### prevod do ANSI, proto tu musi byt UTF a do ANSI se prevede az jednotlivy string
    Xml.LoadFromString(sXml);
{$ifdef CHEXK_XML}
    CheckXmlVersionBasic(Xml);
{$endif}
    GgForm_eIdTag.Text:=XML.Root.Items.Itemnamed['Id'].Value;
    sLabId:=GgForm_eIdTag.Text;
    //{$ifdef DEBUG_HELPER} LDH('Po Load'); {$endif}
    //{$ifdef DEBUG_HELPER} LDH('name='+elem.name); {$endif}
    if(GgForm_eName.Text='') then GgForm_eName.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value)); //toto je i v tom 2. volani
    GgForm_eNameApi.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value)); //toto je i v tom 2. volani
    //ziskame souradnice ikony serie na mape
    lat:=0;
    //{$ifdef DEBUG_HELPER} LDH('Pred Location'); {$endif}
    elem:=XML.Root.Items.Itemnamed['Location'];
    //{$ifdef DEBUG_HELPER} LDH('Po Location'); {$endif}
    s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
    //{$ifdef DEBUG_HELPER} LDH('sLat='+s); {$endif}
    if(s<>'') then lat:=StrToFLoat(s);
    lon:=0;
    s:=elem.Items.Itemnamed['Longitude'].Value;
    //{$ifdef DEBUG_HELPER} LDH('sLon='+s); {$endif}
    if(s<>'') then lon:=StrToFloat(s);
    //GgForm_eCoord.Text:=FormatCoordNum(lat,lon);
    sNew:=(elem.Items.Itemnamed['Latitude'].Value+', '+elem.Items.Itemnamed['Longitude'].Value);
    {$ifdef DEBUG_HELPER} LDH('COORD='+sNew+'/'+GgForm_eCoord.Text); {$endif}
    //if(GgForm_bGGView.Checked) and (GgForm_eCoord.Text<>sNew)
    //  and (GgForm_eCoord.Text<>'') then AddChangeType('COORD');
    GgForm_eCoord.Text:=sNew;
    //pocet labek v serii je i v podrobnostech, ale pod jmenem <TotalGeocachesCount>
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['StagesTotalCount'].Value);
    if(s<>'') then begin //kontrola poctu labek musi byt tady i pri 'StagesTotalCount'
      {$ifdef DEBUG_HELPER} LDH('Pocet labek (1) s='+s+', GgForm_cbCount='+IntToStr(GgForm_cbCount.ItemIndex)); {$endif}
      i:=StrToInt(s);
      if(GgForm_bGGView.Checked) and (GgForm_cbCount.ItemIndex<>i-1) then AddChangeType('NUM');
      GgForm_cbCount.ItemIndex:=i-1;
    end;
    {$ifdef DEBUG_HELPER} LDH('JJJJJJJ pocet labek v serii n='+s); {$endif}
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['SmartLink'].Value);
    //{$ifdef DEBUG_HELPER} LDH('SmartLink='+s); {$endif}
    if(s<>'') then sNew:='https://labs.geocaching.com/goto/'+s
    else sNew:='';
    //pokud jsou nabodenicka, misto SmartLink pouzijeme FirebaseDynamicLink
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['FirebaseDynamicLink'].Value);
    //{$ifdef DEBUG_HELPER} LDH('FirebaseDynamicLink='+s); {$endif}
{$ifndef USE_SMARTLINK}
    sNew:=s;
{$endif}
    //protoze jsou pouzita nabodenicka, pouzijeme DynamicLink, ktery na Adnroidu funguje
    if(not IsAscii(sNew)) then begin
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>s) then AddChangeType('LINK');
      GgForm_eUrlQr.Text:=s;
    end
    else begin
{$ifndef USE_SMARTLINK}
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>sNew) then AddChangeType('LINK');
{$else}
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>sNew) then AddChangeType('SMART');
{$endif}
      GgForm_eUrlQr.Text:=sNew;
    end;
{$ifndef USE_SMARTLINK}
    if(s<>'') then GgForm_eUrlQr.Text:=s;
{$endif}
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['StagesTotalCount'].Value); //toto je i v tom 2. volani
    i:=StrToInt(s);
    {$ifdef DEBUG_HELPER} LDH('Pocet labek (2) i='+IntToStr(i)+', GgForm_cbCount='+IntToStr(GgForm_cbCount.ItemIndex)); {$endif}
    if(GgForm_bGGView.Checked) and (GgForm_cbCount.ItemIndex<>i-1) then AddChangeType('NUM');
    GgForm_cbCount.ItemIndex:=i-1;
    //{$ifdef DEBUG_HELPER} LDH('JJJJJJJ index 1. labky v ComboBoxu='+IntToStr(GgForm_cbCount.ItemIndex)); {$endif}
    SerieChange(GgForm_cbCount);
    sNew:=UtfToAnsi(XML.Root.Items.Itemnamed['Description'].Value); //toto je i v tom 2. volani
    //tady asi muze byt problem s radkovanim, je jinak nez v zobrazenem textu
    //proto to porovname az po zapisu do memo pole
    s:=Trim(GgForm_mText.Lines.Text);
    GgForm_mText.Lines.Text:=Trim(sNew);
    if(GgForm_bGGView.Checked) and (GgForm_mText.Lines.Text<>s) then begin
      //{$ifdef DEBUG_HELPER} LDH('Stary text="'+s+'"'); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('Novy text ="'+GgForm_mText.Lines.Text+'"'); {$endif}
      AddChangeType('TXT');
    end;
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['CreatedUtc'].Value);       //datum a cas vytvoreni
    {$ifdef DEBUG_HELPER} LDH('CreatedUtc='+s); {$endif}
    iYear:=StrToIntDef(Copy(s,1,4),0);
    iMon:=StrToIntDef(Copy(s,6,2),0);
    iDay:=StrToIntDef(Copy(s,9,2),0);
    dt:=0;
    TryEncodeDate(iYear,iMon,iDay,dt);
    if(GgForm_cbId.Text='') then GgForm_dtCreate.Date:=dt;
    //s:=UtfToAnsi(XML.Root.Items.Itemnamed['IsArchived'].Value);       //archivovana
    //polozka IsArchived je nespolehliva, casto je false i kdyz neni serie videt
    //protoz pouzijeme Visibility
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['Visibility'].Value);
    if(s='Public') then s:='false'
    else s:='true';
    if(GgForm_bGGView.Checked) then begin //doplnime ARCH do priznaku zmen
      if(GgForm_bArchiv.Checked<>(LowerCase(s)='true')) then AddChangeType('ARCH');
      if(not GgForm_bArchiv.Checked<>(LowerCase(s)='false')) then AddChangeType('ARCH');
    end;
    GgForm_bArchiv.Checked:=(LowerCase(s)='true');
  finally
    Xml.Free();
  end;
end;

function GetStateForGeonames(sCountry,sState:string):string;
var ini:TMemIniFile;
    sCountryAnsi,sStateAnsi:string;
    //s:string;
begin
  //najdeme podel Statu v ini souboru spravny kraj podle GS
  ini:=TMemIniFile.Create(GetMyDir()+'GeonamesToGs.ini');
  try
    sCountryAnsi:={UtfToAnsi}(sCountry);
    sStateAnsi:={UtfToAnsi}(sState);
    {$ifdef DEBUG_HELPER} LDH('Hledam v GeonamesToGs.ini: ['+sCountryAnsi+'], '+sStateAnsi); {$endif}
    Result:=ini.ReadString(sCountryAnsi,sStateAnsi,sStateAnsi);
    {$ifdef DEBUG_HELPER} LDH('  nalezeno: '+Result);{$endif}
  finally
    ini.Free();
  end;
end;

procedure GetCountryStateFromGeonames(Lat,Lon:double; var country,state:string);
var sUrl,s,s1:string;
    x,y,dist:extended;
begin
  country:='';
  state:='';
  sUrl:='http://www.geonames.org/findNearbyPlaceName?lat='+FloatToStr(Lat)+'&lng='+FloatToStr(Lon)
    +'&style=FULL' //tohle doplni jeste dalsi uroven v <adminName1>, napr 'Hlavni mesto Praha', nadmorskou vysku, kontinent, ...
    ;
  {$ifdef DEBUG_HELPER} LDH('GetCountryStateFromGeonames() - posilam: '+sUrl); {$endif}
  HttpAsk('GET',sUrl,'','',s);
  //{$ifdef DEBUG_HELPER} LDH('Odpoved z geonames.org: (len='+IntToStr(Length(s))+')'+CRLF+s); {$endif}
  if(Length(s)=0) then begin
    ShowMessage('Server geonames asi nefunguje, pro zadane souradnice nevratil zadny text.'
      +' Stat a kraj je potreba vyplnit rucne.');
    exit;
  end;
  if(Length(s)<300) then begin
    ShowMessage('Server geonames vratil podezrele kratky text:'+CRLF+s);
    exit;
  end;
  //zkontrolujeme chybovy navrat
  //Fetch(s,'<status message='
  //zkontrolujeme souradnice, pro ktere vraci geonames hodnoty
  Fetch(s,'<lat>');
  s1:=Fetch(s,'</lat>');
  //s1:=ReplaceString(s1,'.',',');
  {$ifdef DEBUG_HELPER} LDH('s1 pro x: "'+s1+'"'); {$endif}
  x:=StrToFloat(s1);
  Fetch(s,'<lng>');
  s1:=Fetch(s,'</lng>');
  //s1:=ReplaceString(s1,'.',',');
  {$ifdef DEBUG_HELPER} LDH('s1 pro y: "'+s1+'"'); {$endif}
  y:=StrToFloat(s1);
  dist:=PointDistance(Lat, Lon, x, y); //vzdalenost v kilometrech
  if(dist>0.050) then ShowMessage('!!! Pozor, hodnoty vracene z **geonames.org** jsou ze '
    +'souradnic o '+IntToStr(Trunc(dist*1000))+' m !!!'+CRLF+CRLF
    +'Vzdalenost je vetsi nez 50 m a zjisteny stat/kraj se muze lisit od skutecnosti.');
  Fetch(s,'<countryName>');
  country:=Fetch(s,'</countryName>');
  Fetch(s,'<adminName1>');
  state:=Trim(UtfToAnsi(Fetch(s,'<')));
  {$ifdef DEBUG_HELPER} LDH('ItemIndex='+IntToStr(GgForm_cbCountry.ItemIndex)); {$endif}
  //upravime jmeno kraje
  {$ifdef DEBUG_HELPER} LDH('Kraj z geonames: "'+state+'"'); {$endif}
  //nektera jmena jsou vracena s lokalnim jmenem, jina s mezinarodnim
  //nekdy chybi "kraj", ... :(
  //Slovenske kraje maji i to 'kraj', tak neni treba se s nimi zabyvat
  if(state<>'') then begin //zjistena jmena nejsou stejna jako v GG, upravime je
    if((state[length(state)]='')) then state:=state+' kraj'
    else state:=GetStateForGeonames(country,state);
  end;
  {$ifdef DEBUG_HELPER} LDH('Geoname.org - zjisten Kraj: "'+state+'"'); {$endif}
end;

procedure GetCountryStateFromLocationiq(Lat,Lon:double; var country,state:string);
var sUrl,s,sRes:string;
begin
  country:='';
  state:='';
  sUrl:=AddPassword(sWEBPUB_URL);
  //County je okres, ne kraj
  //s:=AddPostParam('','f','getLocationCountryAndCounty');
  s:=AddPostParam('','f','getLocationCountryStateAndCounty');
  s:=AddPostParam(s,'lat',FloatToStr(Lat));
  s:=AddPostParam(s,'lon',FloatToStr(Lon));
  //pridame identifikaci pluginu a ukoncime parametry
  s:=AddPostSender(s)+PostBoundary();
  //{$ifdef DEBUG_HELPER} LDH('@@@@@@@@@@@@ sUrl='+sUrl);{$endif}
  //{$ifdef DEBUG_HELPER} LDH('@@@@@@@@@@@@ parametry='+CRLF+s);{$endif}
  //vysledek neni v XML, ale plain text, stat od
  HttpAsk('POST',sUrl,'multipart/form-data; boundary='+POST_BOUNDARY,s,sRes);
  sRes:=UtfToAnsi(sRes);
  {$ifdef DEBUG_HELPER} LDH('@@@@@@@@@@@@ stat a kraj zjisteny z locationiq: '+sRes);{$endif}
  //zda se, ze je to v kazdem statu jinak:
  //Cesko ma kraj v <county>, <state> je spolecne napr. pro Liberecky a Kralovehradecky kraj
  //Slovensko ma kraj ve <state>, v <county> je okres
  //nekdy vsak neni <county> vraceno
  country:=Fetch(sRes,';');
  state:=Fetch(sRes,';');
  if((country='Czechia') and (Trim(sRes)<>'')) then state:=Trim(sRes);
  //zjistena jmena nejsou stejna jako v GG, upravime je podle INI souboru
  if(state<>'') then begin
    state:=GetStateForGeonames(country,state);
  end;
  {$ifdef DEBUG_HELPER} LDH('zjisten Kraj: "'+state+'"'); {$endif}
end;

procedure GetLabsInfo(sLabId,sXml:String);      /////nacte informace o vsech labkach v serii
var s,sUrl,sNew,sImgUrl,sVideo,sImgUrlAward,sVideoAward,sMessageAward,sQuestion,
      sChoices,sCountry,sState:string;
    Xml:TJclSimpleXML;
    elem,elemCh,elemChs,eItems: TJclSimpleXMLElem;
    i,idx,iCh:integer;
    x,y:extended;
begin
  if(sXml='') then begin //pokud neni zadany string s XML, nacteme jej
    //pres nas server
    sUrl:=sWEB_URL;
    s:=AddPostParam('','f','showXmlDetail');
    s:=AddPostParam(s,'fn',sLabId);
    //pridame identifikaci pluginu a ukoncime parametry
    s:=AddPostSender(s)+PostBoundary();
    {$ifdef DEBUG_HELPER} LDH('1. sUrl='+sUrl);{$endif}
    HttpAsk('POST',sUrl,'multipart/form-data; boundary='+POST_BOUNDARY,s,sXml);
    StringToFile(sXml,GetOfflineDir()+'ApiLabsInfo.xml');
    if(Length(sXml)<500) then begin
      ShowMessage('Chyba nacitani dat z API (detaily serie).');
      exit;
    end;
  end;
  {$ifdef DEBUG_HELPER} LDH('Pred nactenim CmpGetForm() n='+IntToStr(rCmpOld.nCount));{$endif}
  CmpGetForm(); //nacist data z formulare pro kontrolu poradi labek
  {$ifdef DEBUG_HELPER} LDH('Po nacteni CmpGetForm()    n='+IntToStr(rCmpOld.nCount));{$endif}
  Xml:=TJclSimpleXml.Create();
  try
    //parsujeme XML
    Xml.LoadFromString((sXml));
    if(GgForm_cbCount.ItemIndex<0) then ShowMessage('WARN: srie nem definovanou dnou LABku.')
{$ifdef CHEXK_XML}
    else CheckXmlVersionDetail(Xml)
{$endif}
    ;
    CmpGetXml(Xml); //nacteme data pro kontrolu poradi labek
    //pokud je stary pocet mensi, doplnime prazdnymi daty
    if(rCmpNew.nCount>=MAX_LAB) then begin
      ShowMessage('ERR: Serie ma prilis labek, nelze ji spolehlive zpracovat');
    end;
    for i:=rCmpOld.nCount to rCmpNew.nCount-1 do begin
      rCmpOld.Items[i].sGc:='';
      rCmpOld.Items[i].sName:='';
      rCmpOld.Items[i].sLabIdOrd:='';
      rCmpOld.Items[i].sCoord:='';
      rCmpOld.Items[i].idx:=-1;
      rCmpOld.Items[i].iCmpType:=0;
      rCmpOld.Items[i].iOk:=0;
      rCmpOld.bCoord:=false;
      rCmpOld.nCount:=i+1;
    end;
    //GgForm_butLabOrder.Enabled:=false;
    {b:=}CmpSetLabIndex(); //nastav poradi labek v nove i stare serii
    //pokud neni stejne poradi ve stare a nove verzi, zpristupnime tlacitko
    for i:=0 to rCmpNew.nCount-1 do begin
      if(rCmpNew.Items[i].idx<>i) and (GgForm_bGGView.Checked) then begin
        GgForm_butLabOrder.Enabled:=true;
        AddChangeType('ORD');
        break;
      end;
    end;
    for i:=0 to MAX_LAB do aLabOld[i]:=aLab[i];   //abychom porovnavali se starym stavem
    GgForm_eIdTag.Text:=XML.Root.Items.Itemnamed['Id'].Value;
    sLabId:=GgForm_eIdTag.Text;
    //#### pro id=0f088495-bfac-4285-ae87-9be7b89eed03 to tu nejde, kdyz je pouzit
    //#### prevod do ANSI, proto tu musi byt UTF a do ANSI se prevede az jednotlivy string
    sNew:=UtfToAnsi(XML.Root.Items.Itemnamed['OwnerUsername'].Value);
    //if(GgForm_bGGView.Checked) and (GgForm_eNick.Text<>sNew) then GgForm_eChangeGpx.Text:=GgForm_eChangeGpx.Text+' ???';
    GgForm_eNick.Text:=sNew;
    butOwnerIdOnClick(nil);
    //{$ifdef DEBUG_HELPER} LDH('AAA po butOwnerIdOnClick'); {$endif}
    //popis, jmeno a pocet lanek v serii je i v BasicInfo, ale pro pripad, ze je
    //nacitano ze souboru, tak ho nacteme i odtud
    GgForm_mText.Lines.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Description'].Value));
    GgForm_eNameApi.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value));
    //v BasicInfo je to pod <StagesTotalCount>
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['TotalGeocachesCount'].Value);
    if(s<>'') then GgForm_cbCount.ItemIndex:=StrToInt(s)-1;
    //{$ifdef DEBUG_HELPER} LDH('===========ownerid nacten=============='); {$endif}
    eItems:=XML.Root.Items.Itemnamed['GeocacheSummaries'];
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['IsLinear'].Value);       //sekvencni
    //{$ifdef DEBUG_HELPER} LDH('seq='+s); {$endif}
    if(GgForm_cbId.Text<>'') then begin //doplnime SEQ do priznaku zmen
      if(GgForm_bSeq.Checked<>(LowerCase(s)='true')) then AddChangeType('SEQ');
    end;
    GgForm_bSeq.Checked:=(LowerCase(s)='true');
    //{$ifdef DEBUG_HELPER} LDH('BBB'); {$endif}
    for i:=0 to eItems.items.count-1 do begin
      {$ifdef DEBUG_HELPER} LDH('BBB 0 i='+IntToStr(i)); {$endif}
      GgForm_cbLabView.ItemIndex:=i;
      {$ifdef DEBUG_HELPER} LDH('BBB 1 ItemIndex='+IntToStr(GgForm_cbLabView.ItemIndex)); {$endif}
      cbLabViewOnChange(GgForm_cbLabView);
    //{$ifdef DEBUG_HELPER} LDH('BBB 2'); {$endif}
      elem:=eItems.items[i];
    //{$ifdef DEBUG_HELPER} LDH('BBB 3'); {$endif}
      //testujeme proti hodnotam, ktere jsou u spravnych labek
      s:=Trim(UtfToAnsi(elem.Items.Itemnamed['Title'].Value));
    //{$ifdef DEBUG_HELPER} LDH('BBB 4 i='+IntToStr(i)+', count='+IntToStr(rCmpNew.nCount)); {$endif}
    {$ifdef DEBUG_HELPER} LDH('BBB 5 idx='+IntToStr(rCmpNew.Items[i].idx)); {$endif}
      idx:=rCmpNew.Items[i].idx;
      //{$ifdef DEBUG_HELPER} LDH('CCC Name='+aLabOld[idx].sName+' =? '+s); {$endif}
      if(GgForm_bGGView.Checked) and (aLabOld[idx].sName<>s) then  AddChangeType('NAME');
      GgForm_eLabName.Text:=s;          //jmeno labky
      //{$ifdef DEBUG_HELPER} LDH('DDD jmeno='+GgForm_eLabName.Text); {$endif}
      GgForm_eLabIdOrd.Text:=Trim(UtfToAnsi(elem.Items.Itemnamed['Id'].Value));            //Id labky (ne cele serie!)
      //{$ifdef DEBUG_HELPER} LDH('ddd ID labky='+GgForm_eLabIdOrd.Text); {$endif}
      GgForm_mLabText.Lines.Text:=Trim(UtfToAnsi(elem.Items.Itemnamed['Description'].Value));    //popis labky
      //{$ifdef DEBUG_HELPER} LDH('popis='+GgForm_mLabText.Lines.Text); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('EEE'); {$endif}
      s:=UtfToAnsi(elem.Items.Itemnamed['GeofencingRadius'].Value);
      //{$ifdef DEBUG_HELPER} LDH('radius='+s); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('FFF'); {$endif}
      sQuestion:=UtfToAnsi(elem.Items.Itemnamed['Question'].Value);       //otazka
      //{$ifdef DEBUG_HELPER} LDH('dotaz='+s); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('GGG'); {$endif}
      if(GgForm_bQuestion.Checked) then
        GgForm_mLabText.Lines.Text:=GgForm_mLabText.Lines.Text+CRLF+CRLF+'['+sQuestion+']';
      sImgUrl:=UtfToAnsi(elem.Items.Itemnamed['KeyImageUrl'].Value);  //odkaz na obrazek
      sVideo:=UtfToAnsi(elem.Items.Itemnamed['DescriptionVideoYouTubeId'].Value);  //odkaz na video
      sImgUrlAward:=UtfToAnsi(elem.Items.Itemnamed['AwardImageUrl'].Value);  //odkaz na obrazek po otazce
      sMessageAward:=UtfToAnsi(elem.Items.Itemnamed['CompletionAwardMessage'].Value);  //zprava po zodpovezeni otazky
      sVideoAward:=UtfToAnsi(elem.Items.Itemnamed['AwardVideoYouTubeId'].Value);  //odkaz na video po otazce
      //seznam nabizenych moznosti
      sChoices:='';
      elemChs:=elem.Items.Itemnamed['MultiChoiceOptions'];
      for iCh:=0 to elemChs.Items.Count-1 do begin
        elemCh:=elemChs.Items[iCh];
        //{$ifdef DEBUG_HELPER} LDH('iCh='+IntToStr(iCh)+', '+elemCh.Items.Itemnamed['Text'].value); {$endif}
        sChoices:=sChoices+elemCh.Items.Itemnamed['Order'].value+' - '
          +elemCh.Items.Itemnamed['Text'].value+CRLF;
      end;
      sChoices:=UtfToAnsi(sChoices);
      //{$ifdef DEBUG_HELPER} LDH('HHH'); {$endif}
      elem:=elem.Items.Itemnamed['Location'];
      if(elem.Items.Count<3) then begin
        ShowMessage('ERR: '+IntToStr(i+1)+'. LABka v serii neobsahuje souradnice');
      end
      else begin
        //{$ifdef DEBUG_HELPER} LDH('III'); {$endif}
        //{b:=}getJsonString(elem,'Latitude',s);
        s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
        //{$ifdef DEBUG_HELPER} LDH('JJJ'); {$endif}
        //{$ifdef DEBUG_HELPER} LDH('lat='+s); {$endif}
        GgForm_eLabCoord.Text:=s+', '+elem.Items.Itemnamed['Longitude'].Value;
        //{$ifdef DEBUG_HELPER} LDH('KKK'); {$endif}
        //{$ifdef DEBUG_HELPER} LDH('lat; lon='+s); {$endif}
      end;
      //{$ifdef DEBUG_HELPER} LDH('IIII title='+aLab[i].sName); {$endif}
      SaveLab(i);   //zaroven nastavi priznak zmeny, pokud je potreba
      //{$ifdef DEBUG_HELPER} LDH('JJJJ '); {$endif}
      aLab[i].sQuestion:=sQuestion;
      aLab[i].sVideoId:=sVideo;
      aLab[i].sImgUrl:=sImgUrl;
      aLab[i].sMessageAward:=sMessageAward;
      aLab[i].sVideoIdAward:=sVideoAward;
      aLab[i].sImgUrlAward:=sImgUrlAward;
      aLab[i].sChoices:=sChoices;
    //{$ifdef DEBUG_HELPER} LDH('LLL'); {$endif}
      {$ifdef DEBUG_HELPER} LDH('KKK ItemIndex='+IntToStr(GgForm_cbLabView.ItemIndex)); {$endif}
    end;
    //predvolime Czechia jako implicitni stat
    //zkusime pres webovou sluzbu najit stat podle GgForm_eLabCoord.Text
    //ale delame to jen kdyz jde o nove vytvarenou serii
    if(GgForm_cbId.Text='') then begin
      ParseWgsStr(GgForm_eCoord.Text,x,y);
      //geonames si obcas vymysli, pouzivame proto napred Locationiq
      GetCountryStateFromLocationiq(x,y,  sCountry,sState); //zjistime stat a kraj z iocationiq
      {$ifdef DEBUG_HELPER} LDH('z labgpx.cz: stat='+sCountry+', kraj='+sState); {$endif}
      if(sCountry<>'') then begin
        i:=GgForm_cbCountry.Items.IndexOf(sCountry);
        {$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+', ItemIndex='+IntToStr(GgForm_cbCountry.ItemIndex)); {$endif}
        if(i>-1) then begin
          //zkontrolujeme, zda se stat zmenil, pokud ne, nedelame s tim nic
          if(GgForm_cbCountry.ItemIndex<>i) then begin
            GgForm_cbCountry.ItemIndex:=i;
            cbCountryOnChange(nil);
            //{$ifdef DEBUG_HELPER} LDH('Zmena statu'); {$endif}
            //jeste zkusime nastavit spravne kraj podle statu
            GgForm_cbState.ItemIndex:=GgForm_cbState.Items.IndexOf(sState);
            //kraj se nastavit nepodarilo, zkusime nacist hodnoty z geonames.org
            if(GgForm_cbState.ItemIndex<0) then begin
              ShowMessage('Z Locationiq.com se nepodarilo ziskat kraj znam pro GG. Proto pouziji Geonames.org.');
              GetCountryStateFromGeonames(x,y,  sCountry,sState); //zjistime stat a kraj z Geonames
              GgForm_cbState.ItemIndex:=GgForm_cbState.Items.IndexOf(sState);
            end;
            cbStateOnChange(nil);
          end;
        end
        else ShowMessage('Nepodailo se zjistit ani sprvn stt, nato kraj');
      end;
    end;
    GgForm_cbLabView.ItemIndex:=0;
    //{$ifdef DEBUG_HELPER} LDH('MMM ItemIndex='+IntToStr(GgForm_cbLabView.ItemIndex)); {$endif}
    cbLabViewOnChange(GgForm_cbLabView);
    //{$ifdef DEBUG_HELPER} LDH('NNN ItemIndex='+IntToStr(GgForm_cbLabView.ItemIndex)); {$endif}
  finally
    Xml.Free();
  end;
  //pokud je nekde neurcene poradi, zpristupnime analyzu
  for i:=0 to rCmpOld.nCount-1 do begin
    if(rCmpOld.Items[i].iCmpType<1) or (rCmpOld.Items[i].iCmpType>3) then GgForm_butLabOrder.Enabled:=true;
  end;
  for i:=0 to rCmpNew.nCount-1 do begin
    if(rCmpNew.Items[i].iCmpType<1) or (rCmpNew.Items[i].iCmpType>3) then GgForm_butLabOrder.Enabled:=true;
  end;
  //{$ifdef DEBUG_HELPER} LDH('YYY ItemIndex='+IntToStr(GgForm_cbLabView.ItemIndex)); {$endif}
  //{$ifdef DEBUG_HELPER} LDH('ZZZ'); {$endif}
end;

